/***
*
*  Num.prg
*  ਬ 짮⥫᪮ 㭪樨  樨  ᫠
*
*  Copyright, Nantucket Corporation, 1990
*
*  ஢  ﬨ: /n/w/a/m
*/
/***********
* 䨪 ந  ""  ५ -  1991 .
*     祭 Nantucket Corp.
* ⥫.: (095) 289-43-00, (095) 289-44-77, (095) 289-44-83
* 䠪: (095) 289-34-69
************/


/***
*  BaseToBase( <cInString>, <nInBase>, <nOutBase> ) --> cNewBaseValue
*  ८ࠧ ᫮   ப    ⥬ ᫥ 
*     ⥬ ᫥  2  36
*
*  Jake Jacob and Flemming Ho
*
*  ஢  樥 /dNOARGCHECK   ஢ન 㬥⮢
*
*/
FUNCTION BaseToBase( cInString, nInBase, nOutBase )
   LOCAL DIGITS := "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ", cNewBaseValue := ""
   LOCAL i, DecPos, IntValue := 0, FracValue := 0.000000000000000000
   LOCAL FracProduct, FracCounter, IntProdStr, FracOutStr, IntOutString
   LOCAL IntStr, FracString, FracLimit, Block, LChr, Remainder, Quotient
   LOCAL NegSign

   cInString := UPPER( ALLTRIM( cInString ) )

   #ifndef NOARGCHECK
   // ஢ઠ ࠬ஢
   IF EMPTY( cInString ) .OR. VALTYPE( cInString ) <> "C" .OR. LEN( cInString ) > 19
      cNewBaseValue := NIL
   ELSE
      nInBase := IF( EMPTY( nInBase  ), 10, nInBase  )
      nOutBase := IF( EMPTY( nOutBase ), 10, nOutBase )
      IF VALTYPE( nInBase ) <> "N" .OR. VALTYPE( nOutBase ) <> "N"
         cNewBaseValue := NIL
      ELSE
         // ஢ઠ  室   ⥬ ᫥
         IF ( nInBase > 36 .OR. nOutBase > 36 .OR. nInBase < 2 .OR. nOutBase < 2 )
            cNewBaseValue := NIL
         ELSE
            // ஢ઠ  ᮮ⢥⢨   室 ᫠ ⥬ ᫥
            i := 1
            DO WHILE i++ < LEN( cInString ) .AND. cNewBaseValue <> NIL
               IF .NOT. SUBSTR( cInString, i, 1 ) $ ( SUBSTR( DIGITS, 1, nInBase ) + "." )
                  cNewBaseValue := NIL
               ENDIF
            ENDDO
         ENDIF
      ENDIF
   ENDIF
   #endif

   IF cNewBaseValue <> NIL

      // ஢ઠ  ⥫쭮 ८ࠧ㥬 ᫮
      NegSign := IF( SUBSTR( cInString, 1, 1 ) == "-", "-", "" )
      IF .NOT. EMPTY( NegSign )
         cInString := SUBSTR( ALLTRIM( SUBSTR( cInString, 2 ) ), 2 )
      ENDIF

      // । 樨 筮 窨
      DecPos := AT( ".", cInString )
      IntStr := IF( DecPos > 1, SUBSTR( cInString, 1, DecPos - 1 ), IF( DecPos == 1, "0", cInString ) )
      FracString := IF( DecPos > 0, SUBSTR( cInString, DecPos + 1 ), "0" )

      // ८ࠧ 楫   ப   ᫮
      //  筮 ⥬ ᫥
      FOR i = LEN( IntStr ) TO 1 STEP -1
         IntValue += ( AT( SUBSTR( IntStr, i, 1 ), DIGITS) - 1) * ( nInBase ** ( LEN( IntStr ) - i ) )
      NEXT

      // ८ࠧ ஡   ப   ᫮
      //  筮 ⥬ ᫥
      FOR i := 1 TO LEN( FracString )
         FracValue += ( AT( SUBSTR( FracString, i, 1 ), DIGITS ) - 1 ) * ( nInBase ** ( - i ) )
      NEXT

      // ᫥ 楫  室 ப
      Quotient := IntValue
      IntOutString := ""

      DO WHILE Quotient <> 0
         Remainder := Quotient % nOutBase
         Quotient  := INT( Quotient / nOutBase )
         IntOutString := SUBSTR( Digits, Remainder + 1, 1 ) + IntOutString
      ENDDO

      IntOutString := IF( EMPTY( IntOutstring ), "0", IntOutString )

      // ᫥ ஡  室 ப
      FracLimit := 19 - DecPos
      FracProduct := FracValue
      FracCounter := 1
      FracOutStr  := ""

      // ᫨  ᫥饬 WHILE-  ᫮ 
      // FracCounter++ < FracLimit .AND. FracProduct < 0.00000000000001,
      // ⮣  㤥 室 믮    祭
      // 墮⮢ 㫥

      DO WHILE FracCounter++ < FracLimit .AND. FracProduct <> 0
         IntProdStr  := FracProduct * nOutBase
         FracOutStr  := FracOutStr + SUBSTR( Digits, INT( IntProdStr ) + 1, 1 )
         FracProduct := IntProdStr - INT( IntProdStr )
      ENDDO

      // 祭 墮⮢ 㫥  ஡ 
      Block:={ || LChr := RIGHT(FracOutStr, 1), ;
         IF(LChr == "0", FracOutStr := SUBSTR(FracOutStr, 1, LEN(FracOutStr) - 1), 0), ;
         IF(LChr == "0", EVAL(Block), FracOutStr) }
      FracOutStr := EVAL( Block )

      /*     ,  ॡ  
         Block := { |Str| IF(RIGHT(Str, 1) == "0", ;
            EVAL(Block, SUBSTR(FracOutStr, 1, LEN(FracOutStr) - 1)), Str)}
      */
   ENDIF

   // ନ஢ 頥 ப
   IF cNewBaseValue <> NIL
      cNewBaseValue := IF( DecPos > 0, NegSign + IntOutString + "." + FracOutStr, IntOutString )
   ENDIF

   RETURN cNewBaseValue



/***
*  Ceiling( <nNumber> ) --> nInteger
*  頥 襥 楫, ஥   ࠢ 稭 <nNumber>
*  (㣫  襬)
*/
FUNCTION Ceiling( nNumber )
   LOCAL nInteger

   IF (INT(nNumber) = nNumber) .OR. (nNumber < 0)
      //   ⥫쭮 ᫮
      nInteger := INT(nNumber)

   ELSEIF (nNumber > 0)
      // ⥫쭮  楫
      nInteger := INT(nNumber + 1)

   ENDIF

   RETURN nInteger



/***
*  Dtor( <nDegrees> ) --> nRadians
*  ८ࠧ 稭 㣫  ࠤ᭮   ࠤ
*
*/
FUNCTION Dtor( nDegrees )
   RETURN ((nDegrees/180) * PI())



/***
*  Floor( <nNumber> ) --> nInteger
*  頥 襥 楫, ஥   ࠢ 稭 <nNumber>
*  (㣫  襣)
*/
FUNCTION Floor( nNumber )
   LOCAL nInteger

   IF (INT(nNumber) = nNumber) .OR. (nNumber > 0)
      //   ⥫쭮  楫
      nInteger := INT(nNumber)

   ELSEIF (nNumber < 0)
      // ⥫쭮  楫
      nInteger := INT(nNumber - 1)

   ENDIF

   RETURN nInteger



/***
*  NumAsCurrency( <nNumber>, <cSymbol>, <nSide> ) --> cCurrency
*  ८ࠧ ᫠   ଠ, ⠢ ᨬ
*   
*/
FUNCTION NumAsCurrency( nNumber, cSymbol, nSide )
   LOCAL cCurrency
   // ᫨ nSide ⥫쭮, ᨬ   ᯮ ᫥
   IF nSide < 0
      cCurrency := cSymbol + LTRIM(STR(nNumber))
   //   - ࠢ
   ELSE
      cCurrency := RTRIM(STR(nNumber)) + cSymbol
   ENDIF
   RETURN cCurrency



/***
*  NumAsLog10( <nNumber> ) --> nLog10
*     ᭮ 10
*
*/
FUNCTION NumAsLog10( nNumber )
   IF nNumber > 0
      RETURN LOG(nNumber)/LOG(10)
   ENDIF

   RETURN NIL



/***
*  NumGetDecimals( <nNumber> ) --> nDecimals
*  । ⢮  
*
*/
FUNCTION NumGetDecimals( nNumber )
   LOCAL cNum, nPos
   cNum := STR(nNumber)
   nPos := AT(".", cNum)
   IF nPos > 0
      RETURN(LEN(ALLTRIM(SUBSTR(cNum, nPos + 1))))
   ENDIF

   RETURN 0



/***
*  NumGetLen( <nNumber> ) --> nDigits
*  । ⢮    楫  ᫠
*
*/
FUNCTION NumGetLen( nNumber )
   LOCAL cNum
   cNum := STR(INT(ABS(nNumber)))
   RETURN(LEN(ALLTRIM(cNum)))



/***
*  PI() --> nPI
*  ਬ୮ 祭 ᫠ 
*
*/
FUNCTION PI()
   RETURN (3.1415926535897932384626433)



/***
*  Rtod( <nRadians> ) --> nDegrees
*  ८ࠧ 稭 㣫  ࠤ   ࠤ
*
*/
FUNCTION Rtod( nRadians )
   RETURN (180 * (nRadians/PI()))



/***
*  Sign( <nNumber> ) --> nSign
*  頥  ᫠ (-1, 0, 1)
*
*/
FUNCTION Sign( nNumber)
   LOCAL nSign
   DO CASE
   CASE nNumber = 0
      nSign := 0
   CASE nNumber > 0
      nSign := 1
   CASE nNumber < 0
      nSign := -1
   ENDCASE
   RETURN nSign