****
*   Tbdemo.prg
*    TBROWSE  GET-ꥪ⮢
*   Copyright (c) 1990-1991 Nantucket Corp.   ࠢ ࠭.
*
*   :  CLIPPER Tbdemo /m/n/w
*   ઠ    :  RTLINK FILE Tbdemo
*   믮:  Tbdemo <dbf> [<ntx>]
*
/***********
* 䨪 ந  ""  ५ -  1991 .
*     祭 Nantucket Corp.
* ⥫.: (095) 289-43-00, (095) 289-44-77, (095) 289-44-83
* 䠪: (095) 289-34-69
************/


#include "Inkey.ch"
#include "Setcurs.ch"
#include "Error.ch"


// 騥  #define ᯮ ஥ ६ TBrowse-
// ꥪ "cargo"  ࠭ ਧ "०  ᥩ".
// ᯮ짮  #define    ᯮᮡ ࠭,
//  砥 ᫨ 室  ⮩ ६ ࠭ 㣨 .
#define TURN_ON_APPEND_MODE(b)      (b:cargo := .T.)
#define TURN_OFF_APPEND_MODE(b)     (b:cargo := .F.)
#define IS_APPEND_MODE(b)           (b:cargo)


// ப ࠧ⥫  ⠡ ᬮ
#define MY_HEADSEP      ""
#define MY_COLSEP       "  "



***
*   Tbdemo <dbf> [<index>]
*

PROCEDURE Tbdemo( dbf, index )

    LOCAL bSaveHandler, error
    LOCAL cScreen, cColor


    // 饭 ஫ 訡 ६ ᯮ
    bSaveHandler := ERRORBLOCK( {|x| BREAK(x)} )

    BEGIN SEQUENCE
        USE (dbf) INDEX (index)

    RECOVER USING error
        IF error:genCode == EG_OPEN
            ?? "訡   "

        ELSE
            // ।,  ஡ 易  ࠬࠬ
            ?? "ᯮ짮: Tbdemo <dbf> [<index>]"

        ENDIF

        QUIT
    END

    // ⠭ 砫쭮 ணࠬ ࠡ⪨ 訡
    ERRORBLOCK(bSaveHandler)


    // ࠭ ࠦ, 梥⮢ ᯥ䨪樨  ..
    cScreen := SAVESCREEN()
    cColor  := SETCOLOR("N/BG")
    CLEAR SCREEN

    MyBrowse(3, 6, MAXROW() - 2, MAXCOL() - 6)

    // ⠭ 室 ࠬ஢
    SETCOLOR(cColor)
    @ MAXROW(), 0
    RESTSCREEN(,,,,cScreen)

    QUIT



***
*   MyBrowse()
*    Tbrowse-ꥪ  ᬮ     
*

STATIC PROCEDURE MyBrowse(nTop, nLeft, nBottom, nRight)

    LOCAL browse                        // TBrowse-ꥪ
    LOCAL cColorSave, nCursSave         // ६  ࠭
    LOCAL nKey                          // INKEY()- ⮩ 
    LOCAL lMore                         // ࠢ 横


    //  Tbrowse-ꥪ  ⥪饩 ࠡ祩 
    browse := StockBrowseNew(nTop, nLeft, nBottom, nRight)

    //  樮 ணࠬ ᯮ ᯮ㥬
    // ७ ६ "cargo"  ᮤঠ ᪮
    // 祭 "⨭" (.T.),  ᬮ ⢫ 
    // ०  ᥩ,  - "" (. #defines ).
    TURN_OFF_APPEND_MODE(browse)

    //  ࠢ ய᪮ ᥩ  ०  (. ).
    browse:skipBlock := { |x| Skipper(x, browse) }


    //  ࠧ⥫   
    browse:headSep := MY_HEADSEP
    browse:colSep := MY_COLSEP

    // ⮢ ࠢ
    FancyColors(browse)

    // ⠢ ᫥   ".#"  ९  ࠦ
    AddRecno(browse)


    // ᮢ ⥭ 
    cColorSave := SetColor("N/N")
    @ nTop+1, nLeft+1 CLEAR TO nBottom+1, nRight+1
    SETCOLOR("W/W")
    @ nTop, nLeft CLEAR TO nBottom, nRight
    SETCOLOR(cColorSave)

    // ࠭ ਡ⮢ , 몫祭   ᬮ
    nCursSave := SetCursor(SC_NONE)


    // ᭮ 横
    lMore := .T.
    DO WHILE lMore

        //  ᪠   ९ 
        IF browse:colPos <= browse:freeze
            browse:colPos := browse:freeze + 1
        ENDIF

        // ⠡ 蠥    ,  ᠬ
        nKey := 0
        DO WHILE nKey == 0 .AND. .NOT. browse:stable

            browse:stabilize()
            nKey := InKey()

        ENDDO


        IF browse:stable
            // ⠡ 襭
            IF browse:hitBottom .AND. .NOT. IS_APPEND_MODE(browse)
                // ⨣   ; ४祭  ० 
                TURN_ON_APPEND_MODE(browse)
                nKey := K_DOWN

            ELSE
                IF browse:hitTop .OR. browse:hitBottom
                    TONE(125, 0)
                ENDIF

                // ⮢  ⮬,  ⥪  ⮡ࠦ
                // 冷   ६  砥 ⥢ ࠡ⪨
                browse:refreshCurrent()
                ForceStable(browse)

                // ,  室 ᤥ --  ᫥饣 
                nKey := InKey(0)

            ENDIF

        ENDIF


        IF nKey == K_ESC
            // Esc 砥 襭
            lMore := .F.

        ELSE
            // 믮 ⢨  蠬
            ApplyKey(browse, nKey)

        ENDIF


    ENDDO


    SETCURSOR(nCursSave)

    RETURN



****
*   Skipper()
*   ࠢ ६饭    Tbrowse-ꥪ.
*
*    㭪 ࠢ ०  ᥩ. 
*   砥  ࠬ  ,  筮. ன ࠬ
*    뫪  ᠬ Tbrowse-ꥪ. ᯮ㥬 ஥
*   ६ "cargo" ᮤন ଠ  ⮬, 祭  ०
*    ᥩ.
*
*   砭:  "cargo" ᯮ  #defines  砫 ணࠬ
*

STATIC FUNCTION Skipper(n, browse)

    LOCAL lAppend
    LOCAL i


    lAppend := IS_APPEND_MODE(browse)           // .  #defines
    i := 0

    IF n == 0 .OR. LASTREC() == 0

        // Skip 0 (室  ⥢ ࠡ⪥)
        SKIP 0

    ELSEIF n > 0 .and. RECNO() != LASTREC() + 1

        //  ।
        DO WHILE i < n
            SKIP 1
            IF ( EOF() )
                IF ( lAppend )
                    i++
                ELSE
                    SKIP -1
                ENDIF

                EXIT
            ENDIF

            i++
        ENDDO

    ELSEIF n < 0

        //  
        DO WHILE i > n
            SKIP -1
            IF ( BOF() )
                EXIT
            ENDIF

            i--
        ENDDO

    ENDIF


    RETURN i



***
*   ApplyKey()
*   믮 ⢨  ⮩ 
*
*   砭:  "cargo" ᯮ  #defines  砫 ணࠬ
*

STATIC PROCEDURE ApplyKey(browse, nKey)

    DO CASE
    CASE nKey == K_DOWN
        browse:down()

    CASE nKey == K_PGDN
        browse:pageDown()

    CASE nKey == K_CTRL_PGDN
        browse:goBottom()
        TURN_OFF_APPEND_MODE(browse)

    CASE nKey == K_UP
        browse:up()

        IF IS_APPEND_MODE(browse)
            TURN_OFF_APPEND_MODE(browse)
            browse:refreshAll()
        ENDIF

    CASE nKey == K_PGUP
        browse:pageUp()

        IF IS_APPEND_MODE(browse)
            TURN_OFF_APPEND_MODE(browse)
            browse:refreshAll()
        ENDIF

    CASE nKey == K_CTRL_PGUP
        browse:goTop()
        TURN_OFF_APPEND_MODE(browse)

    CASE nKey == K_RIGHT
        browse:right()

    CASE nKey == K_LEFT
        browse:left()

    CASE nKey == K_HOME
        browse:home()

    CASE nKey == K_END
        browse:end()

    CASE nKey == K_CTRL_LEFT
        browse:panLeft()

    CASE nKey == K_CTRL_RIGHT
        browse:panRight()

    CASE nKey == K_CTRL_HOME
        browse:panHome()

    CASE nKey == K_CTRL_END
        browse:panEnd()

    CASE nKey == K_RETURN
        DoGet(browse)

    OTHERWISE

        KEYBOARD CHR(nKey)
        DoGet(browse)

    ENDCASE


    RETURN



***
*   DoGet()
*   믮 GET  ⥪饩 .
*
*   砭:  "cargo" ᯮ  #defines  砫 ணࠬ
*

STATIC PROCEDURE DoGet(browse)

    LOCAL bIns, lScore, lExit
    LOCAL col, get, nKey
    LOCAL lAppend, xOldKey, xNewKey


    // ஢ઠ  ࠭, ४⭮   ..
    ForceStable(browse)

    // ᫨ ᪠    室,   ⢫
    lAppend := IS_APPEND_MODE(browse)
    IF lAppend .AND. RECNO() == LASTREC() + 1
        APPEND BLANK
    ENDIF


    // ࠭ ⥪饣 祭 ᭮     NIL
    // ( 樨)
    // ( ⮫ . ࠧᠭ  ਨ)
    xOldKey := IF( EMPTY(INDEXKEY()), NIL, &(INDEXKEY()) )


    // ࠭ ﭨ
    lScore := Set(_SET_SCOREBOARD, .F.)
    lExit := Set(_SET_EXIT, .T.)
    bIns := SetKey(K_INS)

    // ⠭  INS  ४祭 ० ⠢/
    //  ᮮ⢥饣   
    SetKey( K_INS, {|| InsToggle()} )

    // ⠭    ⥪饬 ﭨ ०
    SetCursor( IF(ReadInsert(), SC_INSERT, SC_NORMAL) )


    // 뤥 ⥪饣 TColumn-ꥪ  TBrowse
    col := browse:getColumn(browse:colPos)

    //    GET-ꥪ
    get := GetNew(Row(), Col(), col:block, col:heading,, browse:colorSpec)

    // ਥ    ⠭⭮ 㭪樨 ReadModal()
    // :  ᮢ⭮ ᯮ짮    室
    // ᯮ짮 㭪 Rlock()  ஢   㣨 짮⥫.
    ReadModal( {get} )


    // ⠭ ﭨ
    SetCursor(0)
    Set(_SET_SCOREBOARD, lScore)
    Set(_SET_EXIT, lExit)
    SetKey(K_INS, bIns)


    //  ணࠬ 믮 ᫥饥:
    //
    //  ⠡樨 TBrowse 筮 ⠥ ⠢ 뤥 
    //  祩,  뫠 뤥 ࠭.  ,  ᥣ, 
    // ᪫祭 砥  ।   ᮮ饭
    // ""  "", ६ ࠭ 뤥   
    //   ᬮ. TBrowse 樮 室 
    // ᮮ⢥騬 ᯮᮡ. ᫨  筨   
    // ப (  EOF ⨫  ६ ᯮ 室
    //    ᬮ),  TBrowse ⠭  
    // 饩 ,    ⮬   -
    //  .
    //
    //  堭 ଠ쭮 ࠡ⠥  ⨦  筨
    // . ஡, ,   ⮬ 砥,  
    // १ 믮 GET-樨 ⥪  (
    // 樨) ६頥 ⠪   砫 筨 ,
    //   뤥 , ࠭ ᯮ
    //  .  ⮬ 砥 TBrowse ࠭  뤥
    // 樨,  ᫨  ⮬  뤥   , 
    // ࠭.  ,  ९樮     , 
    //  ,  ⮬ ⠢ 뤥 ⠬,   뫮. 
    // १, 뤥   ᮢᥬ   ,
    //  ⮫쪮  ।஢.
    //
    //   ணࠬ ஢, 뫮   稭
    // 祢 饣 ࠦ  ६ GET-樨. ᫨
    // 뫮 ( 뫠   ), ᫥騥  뢠
    //   ࠭  ⠡.  ஢, 
    //   ⥪饩 㣠   ࠭. ᫨  ⠪, 
    // ।,    室 - ""
    // ⥪饩    ਨ ᮮ饭 "" ⨣
    // 뤥 ᮮ⢥饩 樨.
    //
    // 祭 祭 祢 ᭮ ࠦ  (or NIL) ᫥ GET
    xNewKey := IF( EMPTY(INDEXKEY()), NIL, &(INDEXKEY()) )

    //   樮 ணࠬ ० 
    // 몫砥 ᫥   
    TURN_OFF_APPEND_MODE(browse)

    // ᫨   ( ᫨   )
    IF .NOT. (xNewKey == xOldKey) .OR. (lAppend .AND. xNewKey != NIL)

        // ࣠   ࠭
        browse:refreshAll()
        ForceStable(browse)

        //   ⮬,  㤥 㦭  ᫥ ⠡樨
        DO WHILE &(INDEXKEY()) > xNewKey .AND. .NOT. browse:hitTop()
            browse:up()
            ForceStable(browse)
        ENDDO

    ENDIF

    // ஢ઠ ॡ 室  ⥪饩  ᫥ GET
    nKey := LASTKEY()
    IF nKey == K_UP .OR. nKey == K_DOWN .OR. ;
        nKey == K_PGUP .OR. nKey == K_PGDN

        // ࠢ ஬ -- 室  㣮 
        KEYBOARD( CHR(nKey) )

    ENDIF


    RETURN



***
*   ForceStable()
*   믮  ⠡樨  TBrowse.
*

STATIC PROCEDURE ForceStable(browse)

    DO WHILE .NOT. browse:stabilize()
    ENDDO

    RETURN



***
*   InsToggle()
*   ४祭 ० ⠢/   
*

STATIC PROCEDURE InsToggle()

    IF READINSERT()
        READINSERT(.F.)
        SETCURSOR(SC_NORMAL)

    ELSE
        READINSERT(.T.)
        SETCURSOR(SC_INSERT)

    ENDIF

    RETURN



***
*   StockBrowseNew()
*    "ઠ" Tbrowse-ꥪ  ⥪饩 ࠡ祩 
*

STATIC FUNCTION StockBrowseNew(nTop, nLeft, nBottom, nRight)

    LOCAL browse
    LOCAL n, column, cType


    //  TBrowse-ꥪ  㭪樨 TBrowseDB()
    browse := TBrowseDB(nTop, nLeft, nBottom, nRight)

    //      ⥪饩 ࠡ祩 
    FOR n := 1 TO FCount()

        // ᮧ  
        column := TBColumnNew(                                          ;
                                Field(n),                               ;
                                FieldWBlock(Field(n), Select())         ;
                             )

        //    TBrowse-ꥪ
        browse:addColumn(column)

    NEXT


    RETURN browse



***
*   FancyColors()
*   ⠭  梥⮢  TBrowse.
*

STATIC PROCEDURE FancyColors(browse)

    LOCAL n, column
    LOCAL xValue


    // ⠭ ᯨ᪠ 梥⮢  ᯮ짮 TBrowse
    browse:colorSpec := "N/W, N/BG, B/W, B/BG, B/W, B/BG, R/W, B/R"

    //   ᥬ   ᬥ  梥⮢
    FOR n := 1 TO browse:colCount

        //   
        column := browse:getColumn(n)

        // 祭 ਠ  ⥬ ᫥  
        xValue := EVAL(column:block)

        IF VALTYPE(xValue) != "N"
            //  ஢  ᯮ짮 梥 3  4 ("B/W"  "B/BG")
            column:defColor := {3, 4}

        ELSE
            //  ஢ - 梥⮢    뤥 ⥫ 稭
            column:colorBlock := {|x| if( x < 0, {7, 8}, {5, 6} )}

            // ⠭ 梥  㬮砭 (梥  )
            column:defColor := {7, 8}

        ENDIF

    NEXT


    RETURN



***
*   AddRecno()
*    䨪஢  ᫥  ⮡ࠦ  
*

STATIC PROCEDURE AddRecno(browse)

    LOCAL column

    //  TBcolumn-ꥪ
    column := TBColumnNew( "  Rec #", {|| RECNO()} )

    // ⠢   ᠬ   TBrowse
    browse:insColumn(1, column)

    //   䨪樨 ᫥
    browse:freeze := 1

    RETURN