/***
*   examplep.prg
*
*   ਬ Clipper-짮⥫᪨ 㭪権
*/
/***********
* 䨪 ந  ""  ५ -  1991 .
*     祭 Nantucket Corp.
* ⥫.: (095) 289-43-00, (095) 289-44-77, (095) 289-44-83
* 䠪: (095) 289-34-69
************/


/***
*  AMPM( <cTime> ) --> cTime
*
*  ८ࠧ ப ६  12- ᮢ ଠ
*/

FUNCTION AMPM( cTime )

   IF VAL(cTime) = 0
      cTime := "12" + SUBSTR(cTime, 3) + " am"

   ELSEIF VAL(cTime) < 12
      cTime += " am"

   ELSEIF VAL(cTime) = 12
      cTime += " pm"

   ELSE
      cTime := STR(VAL(cTime) - 12, 2) + SUBSTR(cTime, 3) + " pm"

   ENDIF

   RETURN cTime


/***
*   StrZero( <nNumber>, <nLength>, <nDecimals> ) --> cNumber
*
*   ८ࠧ ᫠  ப 䨪஢   騬 ﬨ
*/

FUNCTION StrZero( n, nLength, nDecimals )

   LOCAL cNumber

   IF PCOUNT() = 3
      cNumber = STR(n, nLength, nDecimals)
   ELSEIF PCOUNT() = 2
      cNumber = STR(n, nLength)
   ELSE
      cNumber = STR(n)
   ENDIF

   IF "-" $ cNumber
      // ⥫쭮 ᫮ -  । ﬨ
      RETURN "-" + REPLICATE("0", LEN(cNumber) - LEN(LTRIM(cNumber))) +;
            SUBSTR(cNumber, AT("-", cNumber) + 1)
   ENDIF

   // ⥫쭮 ᫮
   RETURN REPLICATE("0", LEN(cNumber) - LEN(LTRIM(cNumber))) + LTRIM(cNumber)


/***
*	DAYS( <nSeconds> )
*
* 頥 楫 ᫮  室   ᫠ ᥪ㭤
*
* 砭: ⮪    24  頥 㭪樥 TSTRING().
*/

FUNCTION DAYS(cl_secs)
	RETURN INT( cl_secs / 86400 )


/***
*	DBF()
*
* 頥  ⥪饩  
*
* 砭: ।砥  饭  ⥪饩  .
*/

FUNCTION DBF
	RETURN ALIAS()


/***
*	ELAPTIME( <nStartTime>, <nEndTime> )
*
* 頥 ப  ࠧ楩 ६  砫  
*
* 砭: ᫨ 砫쭮 ६  筮, ।
*            室   ⪨. 쪮  24-ᮢ ଠ.
*             24  86400 ᥪ㭤.
*/

FUNCTION ELAPTIME(cl_start, cl_end)

	RETURN TSTRING( IF( cl_end < cl_start, 86400, 0) + ;
					SECS(cl_end) - SECS(cl_start) )


/***
*	FKLABEL( <nFunKey> )
*
* 頥 祭 <nFunKey>- ணࠬ㥬 㭪樮쭮 
*/

FUNCTION FKLABEL(cl_1)

	RETURN IF( cl_1 <= 40 .AND. cl_1 > 0, "F"+LTRIM(STR(cl_1)), "")


/***
*	FKMAX()
* 頥 ᨬ  ணࠬ㥬 㭪樮쭮   
*
* 砭: 䨪  IBM PC/XT/AT ᮢ⨬ .
*/

FUNCTION FKMAX()
  RETURN (40)   // IBM-ᯥ䨪


/***
*	LENNUM( <nNum> )
* 頥   ८ࠧ ᫠  ப
*/

FUNCTION LENNUM(cl_number)
	RETURN LEN(LTRIM(STR(cl_number)))


/***
*	MOD( <expN1>, <expN2> )
*
* 頥 ⮪   <expN1>  <expN2>  ᮮ⢥⢨
*  ⬮ dBASE-㭪樨 MOD()
*
* 砭: 稥  dBASE  Clipper, ⪮  ,
*          ५ "<-->":
*
*         Clipper-:        dBASE-㭪:
*         -----------------        -----------------
*          3 %  3 ::=  0.00        MOD( 3, 3) ::=  0
*          3 %  2 ::=  1.00        MOD( 3, 2) ::=  1
*          3 %  1 ::=  0.00        MOD( 3, 1) ::=  0
*          3 %  0 ::=  0.00  <-->  MOD( 3, 0) ::=  3
*          3 % -1 ::=  0.00        MOD( 3,-1) ::=  0
*          3 % -2 ::=  1.00  <-->  MOD( 3,-2) ::= -1
*          3 % -3 ::=  0.00        MOD( 3,-3) ::=  0
*
*         -3 %  3 ::=  0.00        MOD(-3, 3) ::=  0
*         -3 %  2 ::= -1.00  <-->  MOD(-3, 2) ::=  1
*         -3 %  1 ::=  0.00        MOD(-3, 1) ::=  0
*         -3 %  0 ::=  0.00  <-->  MOD(-3, 0) ::= -3
*         -3 % -1 ::=  0.00        MOD(-3,-1) ::=  0
*         -3 % -2 ::= -1.00        MOD(-3,-2) ::= -1
*         -3 % -3 ::=  0.00        MOD(-3,-3) ::=  0
*
*          3 %  3 ::=  0.00        MOD( 3, 3) ::=  0
*          2 %  3 ::=  2.00        MOD( 2, 3) ::=  2
*          1 %  3 ::=  1.00        MOD( 1, 3) ::=  1
*          0 %  3 ::=  0.00        MOD( 0, 3) ::=  0
*         -1 %  3 ::= -1.00  <-->  MOD(-1, 3) ::=  2
*         -2 %  3 ::= -2.00  <-->  MOD(-2, 3) ::=  1
*         -3 %  3 ::=  0.00        MOD(-3, 3) ::=  0
*
*          3 % -3 ::=  0.00        MOD( 3,-3) ::=  0
*          2 % -3 ::=  2.00  <-->  MOD( 2,-3) ::= -1
*          1 % -3 ::=  1.00  <-->  MOD( 1,-3) ::= -2
*          0 % -3 ::=  0.00        MOD( 0,-3) ::=  0
*         -1 % -3 ::= -1.00        MOD(-1,-3) ::= -1
*         -2 % -3 ::= -2.00        MOD(-2,-3) ::= -2
*         -3 % -3 ::=  0.00        MOD(-3,-3) ::=  0
*/

FUNCTION MOD(cl_num, cl_base)
LOCAL cl_result

	cl_result = cl_num % cl_base

	RETURN IF( cl_base = 0, ;
			   cl_num,;
			   IF(cl_result * cl_base < 0, cl_result + cl_base, cl_result) )


/***
*	READKEY()
*
* 頥 , ।⠢騩    室  ०
* ࠭ ।஢ -  dBASE-㭪樨 READKEY().
*
* 砭:  ।⠢ ࠧ dBASE-㭪樨 READKEY() 
* Clipper-㭪樨 LASTKEY():
*
*      室:    dBASE:      Clipper:
*     --------------     ------      --------
*                       0        室
*     ^D, ^L                 1        室
*                       2        室
*     ࠢ                 3        室
*                       4        室
*                        5        室
*     PgUp                   6          18
*     PgDn                   7           3
*     Esc, ^Q               12          27 (⮫쪮 Esc)
*     ^End, ^W              14          23 (⮫쪮 ^W)
*      ᫥      15       ASCII- ᫥ ᨬ
*     Enter                 15          13
*     ^Home                 33        室
*     ^PgUp                 34        室
*     ^PgDn                 35        室
*     F1                    36        室
*
*         dBASE III  256  室 , ᫨ 짮⥫ 
*         -. Clipper ᯮ ᢮ 㭪 UPDATED()  ।,
*         뫨  .
*/

FUNCTION READKEY()

	DO CASE
		CASE LASTKEY() = 18 						  // PgUp
		   RETURN  6 + IF(UPDATED(), 256, 0)
		CASE LASTKEY() =  3 						  // PgDn
		   RETURN  7 + IF(UPDATED(), 256, 0)
		CASE LASTKEY() = 27 						  // Esc
		   RETURN 12 + IF(UPDATED(), 256, 0)
		CASE LASTKEY() = 23 						  // ^W
		   RETURN 14 + IF(UPDATED(), 256, 0)
		CASE LASTKEY() = 13 						  // Enter
		   RETURN 15 + IF(UPDATED(), 256, 0)
		CASE LASTKEY() = 31 						  // ^PgUp
		   RETURN 34 + IF(UPDATED(), 256, 0)
		CASE LASTKEY() = 30 						  // ^PgDn
		   RETURN 35 + IF(UPDATED(), 256, 0)
    CASE LASTKEY() >= 32              //  ᫥  
		   RETURN 15 + IF(UPDATED(), 256, 0)
		OTHERWISE
		   RETURN 0
	ENDCASE

  RETURN (0)  // 祣  ࠭


/***
* SECS( <ப ६>)
*
* 頥 ᫮ ᥪ㭤, ᮤঠ  । ࠬ
*
*         ᫮ ᥪ㭤  ਮ
*         -------    -----------
*              60    1 
*            3600    1 
*           86400    1 
*/

FUNCTION SECS(cl_time)

	RETURN VAL( 	  cl_time	) * 3600 +;
		   VAL(SUBSTR(cl_time,4)) *   60 +;
		   VAL(SUBSTR(cl_time,7))


/***
*	TSTRING( <seconds> )
*
* ८ࠧ ᥪ㭤  ப ६
*
* ६ ॢ饥 24  頥 㭪樥 DAYS().
*/

FUNCTION TSTRING(cl_secs)

	RETURN STRZERO( INT(MOD(cl_secs/3600, 24)), 2, 0 ) +':'+;
		   STRZERO( INT(MOD(cl_secs/  60, 60)), 2, 0 ) +':'+;
		   STRZERO( INT(MOD(cl_secs 	, 60)), 2, 0 )