/***
*
*   Lblback.prg
*   ⥬ ६ ᯮ  Clipper 5.0 LABEL FORM
*   Copyright (c) 1990 Nantucket Corp.   ࠢ ࠭.
*
*   ஢:  /m/n/w
*/

#include "lbldef.ch"
#include "error.ch"

#define BUFFSIZE        1034          //  䠩 ᠭ ଠ ⨪⪨
#define FILEOFFSET      74            // 砫 ᮤঠ ⨪⪨
#define FIELDSIZE       60
#define REMARKOFFSET    2
#define REMARKSIZE      60
#define HEIGHTOFFSET    62
#define HEIGHTSIZE      2
#define WIDTHOFFSET     64
#define WIDTHSIZE       2
#define LMARGINOFFSET   66
#define LMARGINSIZE     2
#define LINESOFFSET     68
#define LINESSIZE       2
#define SPACESOFFSET    70
#define SPACESSIZE      2
#define ACROSSOFFSET    72
#define ACROSSSIZE      2

// । 䠩 訡
#define  F_OK              0          //  訡
#define  F_EMPTY          -3          //  
#define  F_ERROR          -1          //  訡 - ⨯
#define  F_NOEXIST         2          //  㯥


/***
*  __LblLoad( cLblFile ) --> aLabel
*   ᨢ ᠭ ⨪⪨  ᮮ⢥⢨  ᮤন (.lbl) 䠩
*
*/
FUNCTION __LblLoad( cLblFile )
   LOCAL i, j       := 0                  // 稪
   LOCAL cBuff      := SPACE(BUFFSIZE)    //   䠩
   LOCAL nHandle    := 0                  // ਯ 䠩
   LOCAL nReadCount := 0                  // 稪 ⮢, ⠭  䠩
   LOCAL lStatus    := .F.                // 
   LOCAL nOffset    := FILEOFFSET         // 饭  䠩
   LOCAL nFileError := F_OK               //  䠩 訡
   LOCAL cFieldText := ""                 //   ⥪ ࠦ
   LOCAL err

   //   樠 ᨢ ᠭ ⨪⪨
   LOCAL aLabel[ LB_COUNT ]
   aLabel[ LB_REMARK ]  := SPACE(60)      // ਩ ⨪⪨
   aLabel[ LB_HEIGHT ]  := 5              //  ⨪⪨
   aLabel[ LB_WIDTH ]   := 35             // ਭ ⨪⪨
   aLabel[ LB_LMARGIN ] := 0              //  
   aLabel[ LB_LINES ]   := 1              // ப  ⨪⪠
   aLabel[ LB_SPACES ]  := 0              // 権  ⨪⪠
   aLabel[ LB_ACROSS ]  := 1              // ᫮ ⨪⮪  
   aLabel[ LB_FIELDS ]  := {}             // ᨢ ᠭ  ⨪⪨

   // ⨥ 䠩 ᠭ ଠ ⨪⪨
   nHandle := FOPEN( cLblFile )

   nFileError := FERROR()

   //  訡
   IF nFileError != F_OK
      err := ErrorNew()
      err:severity := 2
      err:genCode := EG_OPEN
      err:subSystem := "FRMLBL"
      Eval(ErrorBlock(), err)
   ENDIF

   //  ⮬  ।,  䠩 ⨪⪨  ⮢  ⥭
   nReadCount := FREAD( nHandle, @cBuff, BUFFSIZE )

   // ⥭ 㤠筮?
   IF nReadCount == 0
      nFileError := F_EMPTY             //  
   ELSE
      nFileError := FERROR()            // ஢ઠ DOS-訡
   ENDIF

   IF nFileError == 0

      //  ࠧ஢ ⨪⪨  ᨢ
      aLabel[ LB_REMARK ] := SUBSTR(cBuff, REMARKOFFSET, REMARKSIZE)
      aLabel[ LB_HEIGHT ] := BIN2W(SUBSTR(cBuff, HEIGHTOFFSET, HEIGHTSIZE))
      aLabel[ LB_WIDTH  ] := BIN2W(SUBSTR(cBuff, WIDTHOFFSET, WIDTHSIZE))
      aLabel[ LB_LMARGIN] := BIN2W(SUBSTR(cBuff, LMARGINOFFSET, LMARGINSIZE))
      aLabel[ LB_LINES  ] := BIN2W(SUBSTR(cBuff, LINESOFFSET, LINESSIZE))
      aLabel[ LB_SPACES ] := BIN2W(SUBSTR(cBuff, SPACESOFFSET, SPACESSIZE))
      aLabel[ LB_ACROSS ] := BIN2W(SUBSTR(cBuff, ACROSSOFFSET, ACROSSSIZE))

      FOR i := 1 TO aLabel[ LB_HEIGHT ]

         //  ࠦ 
         cFieldText := TRIM( SUBSTR( cBuff, nOffset, FIELDSIZE ) )
         nOffset += 60

         IF !EMPTY( cFieldText )

            AADD( aLabel[ LB_FIELDS ], {} )

            //   ࠦ  
            AADD( aLabel[ LB_FIELDS, i ], &( "{ || " + cFieldText + "}" ) )

            //  ࠦ  
            AADD( aLabel[ LB_FIELDS, i ], cFieldText )

            //  ᦠ
            AADD( aLabel[ LB_FIELDS, i ], .T. )

		 ELSE

			AADD( aLabel[ LB_FIELDS ], NIL )

         ENDIF

      NEXT

      // ⨥ 䠩
      FCLOSE( nHandle )
      nFileError = FERROR()

   ENDIF
   RETURN( aLabel )